import serial
import time
import re

def print_bts(bts):
    for n in bts:
        print("{0:0{1}X}".format(n,2), end = " ")
    print()


print('Checking Sensor')

while True:
    state = 0
    bts = b''
    ser = serial.Serial('COM16', 9600, timeout = 3)
    tik = time.time()
    while(time.time() - tik < 9):
        bt = ser.read()
        print(bt.decode("utf-8"), end = '',  flush=True)

        if(state == 0 and bt == b'>'):
            print()
            print('Sensor Ready')
            state = 1
        elif(state == 1):
            print('Writing cfg')
            ser.write(b'cfg:{l:2000,b:300}')
            state = 2
        elif(state == 2 and bt == b'R'):
            state = 3
            ser.write(b'QA')
        elif(state == 3):
            bts += bt

    ser.close()
    rspstr = bts.decode("utf-8")
    vals = rspstr.split('\n')

    try:
        vel         = vals[0].split()[1]
        dist        = vals[1].split()[1]
        amp         = vals[2].split()[1]
        spread      = vals[3].split()[1]
        angle       = vals[4].split()[1]
        peaks       = vals[5].split()[1]
        est_dist    = vals[6].split()[1]
        a_vel       = vals[7].split()[1]
        a_dist_est  = vals[8].split()[1]

        peaks = peaks.split('|')
        peaks = [int(x, 16) for x in peaks]
        pdist = [x >> 16 for x in peaks]
        pamps = [x & 0xFFFF for x in peaks]


        print('========= RESULTS ========')
        print('velocity: ', vel, ' mm/s')
        print('distance: ', dist, ' mm')
        print('fine distance: ', est_dist, ' mm')
        print('amplitude: ', amp)
        print('spread: ', spread)
        print('angle: ', angle, ' deg')
        for a,d in zip(pamps,pdist):
            print('peak: ', d, "mm  | amplitude: ", a)
        print()
        print('fine distance: ', est_dist, ' mm')
        print('angle velocity: ', a_vel, ' mm/s')
        print('angle distance: ', a_dist_est, ' mm')
    
    except IndexError:
        pass
        
    

    
    print('Resetting')
    print('============================')


