## Instructions

Instructions for assembling, programming, and getting started with the radar sensor can be found at the links below:

https://www.bosl.com.au/wiki/Assembling_the_Radar_Sensor
https://www.bosl.com.au/wiki/Getting_Started_With_the_Radar_Sensor

# Sensor Output

The radar sensor may output any of the values to UART in the table below. Depending on current measurement MODE some of these values may not return a valid reading.

| value            | unit  | MODEs | description                                    |
|------------------|-------|-------|------------------------------------------------|
| vel              | mm/s  | 5     | angle uncorrected water velocity               |
| dist             | mm    | 5     | line-of-sight course distance                  |
| amp              | arb   | 5     | amplitude of velocity signal                   |
| spread           | arb   | 5     | spread of velocity signal                      |
| angle            | deg   | 5,7   | declination angle of radar sensor              |
| peaks            | HEX   | 5,7   | HEX output of 4 strongest static reflectors    |
| dist\_est        | mm    | 5,7   | line-of-sight fine distance                    |
| a\_vel           | mm/s  | 5     | angle corrected velocity                       |
| a\_dist\_est     | mm    | 5,7   | angle corrected fine distance                  |
